
# Standard modules
import string
import time

# My modules
from dcUtil import *

class jobTimes:


    # Contructor
    #

    def __init__(self):

        self.clear()

    #
    #
    
    def clear(self):
        
        self.submitTimeDict = {}
        self.segmentTimeDict = {}


    #
    #

    def getJIDList(self):

        return self.submitTimeDict.keys()

    #
    #

    def addSubmitTime(self, JID, time):

        self.submitTimeDict[JID] = time

    
    #
    #

    def addSegment(self, segmentID, procType, startTime, endTime=None):

        JID, sectionName, procNum = string.split(segmentID, ".")
        if self.segmentTimeDict.has_key(JID):
            tmpList = self.segmentTimeDict[JID]
            tmpList.append([segmentID, procType, startTime, endTime])
            self.segmentTimeDict[JID] = tmpList
        else:
            self.segmentTimeDict[JID] = [[segmentID, procType, startTime,
                                          endTime]]

#        stdoutMessage("added %s, %s %s %s" % (segmentID, procType, startTime, endTime))

    
    #
    #

    def updateSegmentEndTime(self, inSegmentID, inEndTime):

        JID, sectionName, procNum = string.split(inSegmentID, ".")

        if not self.segmentTimeDict.has_key(JID):
            stderrMessage("No JID=%s in segmentTimeDict" % JID)
            return -1

        segmentIndex = -1
        segmentList = self.segmentTimeDict[JID]
        for i in range(len(segmentList)):
            segmentID, procType, startTime, endTime = segmentList[i]
            if inSegmentID == segmentID:
                segmentIndex = i
                break
        if segmentIndex == -1:
            stderrMessage("Cannot update segmentID=%s.Not found" % inSegmentID)
            return -1
        else:
            segmentID, procType, startTime, endTime = segmentList[segmentIndex]
            segmentList[segmentIndex]=inSegmentID,procType,startTime,inEndTime
            self.segmentTimeDict[JID] = segmentList
            return segmentIndex

    #
    #

    def getProcType(self, JID):

        if not self.segmentTimeDict.has_key(JID):
            return None

        for segmentID,procType,startTime,endTime in self.segmentTimeDict[JID]:
            if string.find(segmentID, "end") == -1:
                return procType
        
    
    #
    #

    def getWaitTime(self, JID):

        if not self.submitTimeDict.has_key(JID):
            return None

        if not self.segmentTimeDict.has_key(JID):
            return None

        submitTime = self.submitTimeDict[JID]

        startTimeList = []
        for segmentID,procType,startTime,endTime in self.segmentTimeDict[JID]:
            startTimeList.append(startTime)

        startTimeList.sort()     # increasing order -> more recent time

        if len(startTimeList) > 0:
            return startTimeList[0] - submitTime
        else:
            return None

    #
    #

    def getAvgProcessStartTimeDiff(self, JID):

        if not self.segmentTimeDict.has_key(JID):
            return None

        startTimeList = []
        startTimeDiffList = []
        for segmentID,procType,startTime,endTime in self.segmentTimeDict[JID]:
            startTimeList.append(startTime)

        startTimeList.sort()     # increasing order -> more recent time

        firstSegment = 1
        for startTime in startTimeList:
            if firstSegment:
                firstSegment = 0
            else:
                startTimeDiff = startTime - startTimeLast
                startTimeDiffList.append(startTimeDiff)
            startTimeLast = startTime


        avgProcessStartTimeDiff = getAvg(startTimeDiffList)
        return avgProcessStartTimeDiff
        

    #
    #

    def getAvgProcessExecTime(self, JID):

        if not self.segmentTimeDict.has_key(JID):
            return None
        
        execTimeList = []
        firstSegment = 1
        for segmentID,procType,startTime,endTime in self.segmentTimeDict[JID]:
            if endTime != None:
                execTime = endTime - startTime
                execTimeList.append(execTime)

        avgProcessExecTime = getAvg(execTimeList)
        return avgProcessExecTime

    
