
# bpParams.py
#    Global parameters for parsing of CAF batch monitoring data
#
# [Mark Neubauer 7/15/03]


LOG_DIR         = "/home/cafmon/batchmon/log"
DATA_ROOT_DIR   = "/home/cafmon/batchmon/data"
RRD_ROOT_DIR    = "/home/cafmon/batchmon/RRD"
RRDTOOL_BIN     = "/home/cafmon/bin/rrdtool"
GRAPHS_DIR      = "/var/www/html/caf/batchmon/graphs"
PARSER_INTERVAL = 300   


dsDict = {
    "pending":"DS:Nshort:GAUGE:600:U:U DS:Nmedium:GAUGE:600:U:U"
              " DS:Nlong:GAUGE:600:U:U DS:Ngroups:GAUGE:600:U:U"
              " DS:Nother:GAUGE:600:U:U",
    "running":"DS:Nshort:GAUGE:600:U:U DS:Nmedium:GAUGE:600:U:U"
              " DS:Nlong:GAUGE:600:U:U DS:Ngroups:GAUGE:600:U:U"
              " DS:Nother:GAUGE:600:U:U",
    "wait_time":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                " DS:Tother:GAUGE:600:U:U",
    "start_time_diff":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                      " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                      " DS:Tother:GAUGE:600:U:U",
    "exec_time":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                " DS:Tother:GAUGE:600:U:U"
          }

# daily(5min) , weekly(30min),monthly(2hour),yearly(1day)
rraDict = {
    "pending":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
              " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "running":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
              " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "wait_time":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "start_time_diff":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                      " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "exec_time":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                "RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365"
    }

graphGlobal = "-w 455 -h 150 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB "

graphDict = {
    "pending":"--title=\"Number of Pending Processes\" DEF:val1=pending.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=pending.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=pending.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=pending.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=pending.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
    "running":"--title=\"Number of Running Processes\" --lower-limit=0. --upper-limit=600. --rigid DEF:val1=running.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=running.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=running.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=running.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=running.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
    "wait_time":"--title=\"Wait Time for Job to Start\" DEF:val1=wait_time.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=wait_time.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=wait_time.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=wait_time.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=wait_time.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others",
    "start_time_diff":"--title=\"Time Difference Between Processes Starting\" DEF:val1=start_time_diff.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=start_time_diff.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=start_time_diff.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=start_time_diff.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=start_time_diff.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others",
    "exec_time":"--title=\"Process Execution Time\" DEF:val1=exec_time.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=exec_time.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=exec_time.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=exec_time.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=exec_time.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others"
    }

timeIntervals = ["1day", "3days", "1week", "2weeks", "1month", "3months",
                 "1year"]
