#!/local/ups/prd/python/v2_1/Linux-2-4/bin/python

# Standard modules
import sys
import time
import os
import string
import popen2


# Define stdout and stderr write methods
def stdoutMessage(msg):
    os.write(1, "(%s): %s\n" % (time.ctime(time.time()), msg))

def stderrMessage(msg):
    os.write(2, "(%s): ERROR: %s\n" % (time.ctime(time.time()), msg))


LOG_DIR         = "/home/cafmon/batchmon/log"
DATA_ROOT_DIR   = "/home/cafmon/batchmon/data"
RRD_ROOT_DIR    = "/home/cafmon/batchmon/RRD"
RRDTOOL_BIN     = "/home/cafmon/bin/rrdtool"
GRAPHS_DIR      = "/var/www/html/caf/batchmon/graphs"
PARSER_INTERVAL = 300   


dsDict = {
    "pending":"DS:Nshort:GAUGE:600:U:U DS:Nmedium:GAUGE:600:U:U"
              " DS:Nlong:GAUGE:600:U:U DS:Ngroups:GAUGE:600:U:U"
              " DS:Nother:GAUGE:600:U:U",
    "running":"DS:Nshort:GAUGE:600:U:U DS:Nmedium:GAUGE:600:U:U"
              " DS:Nlong:GAUGE:600:U:U DS:Ngroups:GAUGE:600:U:U"
              " DS:Nother:GAUGE:600:U:U",
    "wait_time":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                " DS:Tother:GAUGE:600:U:U",
    "start_time_diff":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                      " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                      " DS:Tother:GAUGE:600:U:U",
    "exec_time":"DS:Tshort:GAUGE:600:U:U DS:Tmedium:GAUGE:600:U:U"
                " DS:Tlong:GAUGE:600:U:U DS:Tgroups:GAUGE:600:U:U"
                " DS:Tother:GAUGE:600:U:U"
          }

# daily(5min) , weekly(30min),monthly(2hour),yearly(1day)
rraDict = {
    "pending":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
              " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "running":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
              " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "wait_time":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "start_time_diff":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                      " RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365",
    "exec_time":"RRA:AVERAGE:0.5:1:288 RRA:AVERAGE:0.5:6:336"
                "RRA:AVERAGE:0.5:24:372 RRA:AVERAGE:0.5:1440:365"
    }

graphGlobal = "-w 455 -h 150 -c BACK\#000000 -c CANVAS\#111133 -c MGRID\#CCCCCC -c FONT\#00EEBB "

graphDict = {
    "pending":"--title=\"Number of Pending Processes\" DEF:val1=pending.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=pending.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=pending.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=pending.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=pending.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
    "running":"--title=\"Number of Running Processes\" --lower-limit=0. --upper-limit=600. --rigid DEF:val1=running.rrd:Nshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=running.rrd:Nmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=running.rrd:Nlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=running.rrd:Ngroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=running.rrd:Nother:AVERAGE LINE2:val5#FF00FF:others CDEF:tot=val1,val2,val3,val4,val5,+,+,+,+ LINE2:tot#aaaaaa:total",
    "wait_time":"--title=\"Wait Time for Job to Start\" DEF:val1=wait_time.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=wait_time.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=wait_time.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=wait_time.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=wait_time.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others",
    "start_time_diff":"--title=\"Time Difference Between Processes Starting\" DEF:val1=start_time_diff.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=start_time_diff.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=start_time_diff.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=start_time_diff.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=start_time_diff.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others",
    "exec_time":"--title=\"Process Execution Time\" DEF:val1=exec_time.rrd:Tshort:AVERAGE LINE2:val1#FFFF00:short DEF:val2=exec_time.rrd:Tmedium:AVERAGE LINE2:val2#BB0000:medium DEF:val3=exec_time.rrd:Tlong:AVERAGE LINE2:val3#3333FF:long DEF:val4=exec_time.rrd:Tgroups:AVERAGE LINE2:val4#00FF00:groups DEF:val5=exec_time.rrd:Tother:AVERAGE LINE2:val5#FF00FF:others"
    }

# Parser class
#

class parser:

    # Contructor
    #

    def __init__(self):

        stdoutMessage("Parser daemon started")


    def processDataFile(self, fileName):

        stdoutMessage("Processing %s" % fileName)
        self.sourceFile = os.path.join(DATA_ROOT_DIR, fileName)
        try:
            self.file = open(self.sourceFile,"r")
        except:
            stderrMessage("error opening file %s" % self.sourceFile)
            return -1


        tmpList = string.split(fileName, ".")
        if len(tmpList) > 1:
            i = string.find(fileName, tmpList[len(tmpList)-1])
            self.baseName = fileName[:i-1]
        else:
            self.baseName = fileName
        self.rrdFile = self.baseName + ".rrd"
        self.rrdFile = os.path.join(RRD_ROOT_DIR, self.rrdFile)

        if not os.path.isfile(self.rrdFile):
            self.createRRD()

        for line in self.file.readlines():
            tmpList = string.split(line, "#")
            if len(tmpList) < 2:
                stderrMessage("bad data format in %s" % self.sourceFile)
            else:
                self.dataTime, dataStr = tmpList
                self.dataList = string.split(dataStr, ",")
            self.updateRRD()

        self.graphFile = self.baseName + ".gif"
        self.graphFile = os.path.join(GRAPHS_DIR, self.graphFile)
        self.updateGraph()

        if self.file != None:
            self.file.close()
        stdoutMessage("unlinking file")
        try:
            os.unlink(self.sourceFile)
        except:
            stdoutMessage("not able to unlink the file")


    def createRRD(self):

        stdoutMessage("Creating %s" % self.baseName)
        dsStr = dsDict[self.baseName]
        rraStr = rraDict[self.baseName]

        startTime = "-86400s"             # allow for entries up to 24hrs prior
        stepTime = 300.                   # feed data in every 5 mins
        command = "%s create %s --start %s --step %s %s %s" % \
               (RRDTOOL_BIN, self.rrdFile, startTime, stepTime, dsStr, rraStr)
        stdoutMessage(command)
        childout, childin, childerr = popen2.popen3(command)
        childin.close()
        tempOut = childout.readlines()
        childout.close()
        tempErr = childerr.readlines()
        childerr.close()

        for line in tempErr:
            line = string.strip(line)
            stderrMessage(line)

        for line in tempOut:
            line = string.strip(line)
            stdoutMessage(line)


    def updateRRD(self):

        valStr = self.dataTime
        for dataElement in self.dataList:
            valStr += ":%s" % float(dataElement)

        command = "%s update %s %s" % (RRDTOOL_BIN, self.rrdFile, valStr)
        stdoutMessage(command)
        childout, childin, childerr = popen2.popen3(command)
        childin.close()
        tempOut = childout.readlines()
        childout.close()
        tempErr = childerr.readlines()
        childerr.close()

        for line in tempErr:
            line = string.strip(line)
            stderrMessage(line)

        for line in tempOut:
            line = string.strip(line)
            stdoutMessage(line)


    def updateGraph(self):

        os.chdir(RRD_ROOT_DIR)
        graphStr = graphGlobal + graphDict[self.baseName]
        command = "%s graph %s %s" % (RRDTOOL_BIN, self.graphFile, graphStr)
        stdoutMessage(command)
        childout, childin, childerr = popen2.popen3(command)
        childin.close()
        tempOut = childout.readlines()
        childout.close()
        tempErr = childerr.readlines()
        childerr.close()

        for line in tempErr:
            line = string.strip(line)
            stderrMessage(line)

        for line in tempOut:
            line = string.strip(line)
            stdoutMessage(line)

        

# Main program
#

def main():


    dataFilesToProcess = ["pending.dat",
                          "running.dat",
                          "wait_time.dat",
                          "start_time_diff.dat",
                          "exec_time.dat"]
    # Open log file
    #

    LOG_FILE = os.path.join(LOG_DIR, "parser.log")
    fd = os.open(LOG_FILE, os.O_WRONLY | os.O_CREAT | os.O_TRUNC)
    os.dup2(fd, 1)
    os.dup2(fd, 2)
    os.close(fd)

    parserObj = parser()
    
    while 1:
        for file in dataFilesToProcess:
            parserObj.processDataFile(file)

        stdoutMessage("hybernating ....")
        time.sleep(PARSER_INTERVAL)


if __name__ == "__main__":

    deamonPid = os.fork()
    if deamonPid > 0:
        sys.exit(0)
    else:
        
        # Trying to make this deamon process
        os.setsid()
        # Becomes a session leader of a new session
        # Becomes the process group leader of a new process group
        # Has no controlling terminal

        os.chdir("/")

        os.umask(0)
        # I also need to close all the unnecessary open file descriptors

        main()


